Package org.springframework.beans.factory.config

# Class PropertyPathFactoryBean

java.lang.Object
org.springframework.beans.factory.config.PropertyPathFactoryBean

All Implemented Interfaces:
  `Aware`, `BeanFactoryAware`, `BeanNameAware`, `FactoryBean<Object>`

public class PropertyPathFactoryBean extends Object implements FactoryBean<Object>, BeanNameAware, BeanFactoryAware
`FactoryBean` that evaluates a property path on a given target object.

The target object can be specified directly or via a bean name.

Usage examples:

    <!-- target bean to be referenced by name -->
     <bean id="tb" class="org.springframework.beans.TestBean" singleton="false">
       <property name="age" value="10"/>
       <property name="spouse">
         <bean class="org.springframework.beans.TestBean">
           <property name="age" value="11"/>
         </bean>
       </property>
     </bean>

     <!-- will result in 12, which is the value of property 'age' of the inner bean -->
     <bean id="propertyPath1" class="org.springframework.beans.factory.config.PropertyPathFactoryBean">
       <property name="targetObject">
         <bean class="org.springframework.beans.TestBean">
           <property name="age" value="12"/>
         </bean>
       </property>
       <property name="propertyPath" value="age"/>
     </bean>

     <!-- will result in 11, which is the value of property 'spouse.age' of bean 'tb' -->
     <bean id="propertyPath2" class="org.springframework.beans.factory.config.PropertyPathFactoryBean">
       <property name="targetBeanName" value="tb"/>
       <property name="propertyPath" value="spouse.age"/>
     </bean>

     <!-- will result in 10, which is the value of property 'age' of bean 'tb' -->
     <bean id="tb.age" class="org.springframework.beans.factory.config.PropertyPathFactoryBean"/>

If you are using Spring 2.0 and XML Schema support in your configuration file(s), you can also use the following style of configuration for property path access. (See also the appendix entitled 'XML Schema-based configuration' in the Spring reference manual for more examples.)

     <!-- will result in 10, which is the value of property 'age' of bean 'tb' -->
     <util:property-path id="name" path="testBean.age"/>

Thanks to Matthias Ernst for the suggestion and initial prototype!

Since:
  1.1.2
Author:
  Juergen Hoeller
See Also:
  - `setTargetObject(java.lang.Object)`
  - `setTargetBeanName(java.lang.String)`
  - `setPropertyPath(java.lang.String)`

## Field Summary

### Fields inherited from interface org.springframework.beans.factory.FactoryBean

`OBJECT_TYPE_ATTRIBUTE`

## Constructor Summary

Constructors
Constructor
Description
`PropertyPathFactoryBean()`

## Method Summary

Modifier and Type
Method
Description
`Object`
`getObject()`
Return an instance (possibly shared or independent) of the object managed by this factory.
`Class<?>`
`getObjectType()`
Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`boolean`
`isSingleton()`
While this FactoryBean will often be used for singleton targets, the invoked getters for the property path might return a new object for each call, so we have to assume that we're not returning the same object for each `getObject()` call.
`void`
`setBeanFactory(BeanFactory beanFactory)`
Callback that supplies the owning factory to a bean instance.
`void`
`setBeanName(String beanName)`
The bean name of this PropertyPathFactoryBean will be interpreted as "beanName.property" pattern, if neither "targetObject" nor "targetBeanName" nor "propertyPath" have been specified.
`void`
`setPropertyPath(String propertyPath)`
Specify the property path to apply to the target.
`void`
`setResultType(Class<?> resultType)`
Specify the type of the result from evaluating the property path.
`void`
`setTargetBeanName(String targetBeanName)`
Specify the name of a target bean to apply the property path to.
`void`
`setTargetObject(Object targetObject)`
Specify a target object to apply the property path to.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### PropertyPathFactoryBean

public PropertyPathFactoryBean()

## Method Details

### setTargetObject

public void setTargetObject(Object targetObject)
Specify a target object to apply the property path to. Alternatively, specify a target bean name.

Parameters:
  `targetObject` - a target object, for example a bean reference or an inner bean
See Also:
  - `setTargetBeanName(java.lang.String)`

### setTargetBeanName

public void setTargetBeanName(String targetBeanName)
Specify the name of a target bean to apply the property path to. Alternatively, specify a target object directly.

Parameters:
  `targetBeanName` - the bean name to be looked up in the containing bean factory (for example, "testBean")
See Also:
  - `setTargetObject(java.lang.Object)`

### setPropertyPath

public void setPropertyPath(String propertyPath)
Specify the property path to apply to the target.

Parameters:
  `propertyPath` - the property path, potentially nested (for example, "age" or "spouse.age")

### setResultType

public void setResultType(Class<?> resultType)
Specify the type of the result from evaluating the property path.

Note: This is not necessary for directly specified target objects or singleton target beans, where the type can be determined through introspection. Just specify this in case of a prototype target, provided that you need matching by type (for example, for autowiring).

Parameters:
  `resultType` - the result type, for example "java.lang.Integer"

### setBeanName

public void setBeanName(String beanName)
The bean name of this PropertyPathFactoryBean will be interpreted as "beanName.property" pattern, if neither "targetObject" nor "targetBeanName" nor "propertyPath" have been specified. This allows for concise bean definitions with just an id/name.

Specified by:
  `setBeanName` in interface `BeanNameAware`
Parameters:
  `beanName` - the name of the bean in the factory. Note that this name is the actual bean name used in the factory, which may differ from the originally specified name: in particular for inner bean names, the actual bean name might have been made unique through appending "#..." suffixes. Use the `BeanFactoryUtils.originalBeanName(String)` method to extract the original bean name (without suffix), if desired.

### setBeanFactory

public void setBeanFactory(BeanFactory beanFactory)
Description copied from interface: `BeanFactoryAware`
Callback that supplies the owning factory to a bean instance.

Invoked after the population of normal bean properties but before an initialization callback such as `InitializingBean.afterPropertiesSet()` or a custom init-method.

Specified by:
  `setBeanFactory` in interface `BeanFactoryAware`
Parameters:
  `beanFactory` - owning BeanFactory (never `null`). The bean can immediately call methods on the factory.
See Also:
  - `BeanInitializationException`

### getObject

@Nullable public Object getObject() throws BeansException
Description copied from interface: `FactoryBean`
Return an instance (possibly shared or independent) of the object managed by this factory.

As with a `BeanFactory`, this allows support for both the Singleton and Prototype design patterns.

If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

FactoryBeans are allowed to return `null` objects. The bean factory will consider this as a normal value to be used and will not throw a `FactoryBeanNotInitializedException` in this case. However, FactoryBean implementations are encouraged to throw `FactoryBeanNotInitializedException` themselves, as appropriate.

Specified by:
  `getObject` in interface `FactoryBean<Object>`
Returns:
  an instance of the bean (can be `null`)
Throws:
  `BeansException`
See Also:
  - `FactoryBeanNotInitializedException`

### getObjectType

@Nullable public Class<?> getObjectType()
Description copied from interface: `FactoryBean`
Return the type of object that this FactoryBean creates, or `null` if not known in advance.

This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

In the case of implementations that create a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore, it is highly recommended to implement this method properly, using the current state of the FactoryBean.

Specified by:
  `getObjectType` in interface `FactoryBean<Object>`
Returns:
  the type of object that this FactoryBean creates, or `null` if not known at the time of the call
See Also:
  - `ListableBeanFactory.getBeansOfType(java.lang.Class<T>)`

### isSingleton

public boolean isSingleton()
While this FactoryBean will often be used for singleton targets, the invoked getters for the property path might return a new object for each call, so we have to assume that we're not returning the same object for each `getObject()` call.

Specified by:
  `isSingleton` in interface `FactoryBean<Object>`
Returns:
  whether the exposed object is a singleton
See Also:
  - `FactoryBean.getObject()`
  - `SmartFactoryBean.isPrototype()`